
#ifndef FREEFRAMEPLUGIN_H
#define FREEFRAMEPLUGIN_H

#include "FreeFrame.h"
#include <atlstr.h>


class FreeFramePlugin
	{
	public:

		FreeFramePlugin();
		~FreeFramePlugin();

		bool Load(const char* dllPath, VideoInfoStruct& videoInfo);

		bool GetInfo(PluginInfoStruct& pluginInfo);
		bool GetExtendedInfo(PluginExtendedInfoStruct& pluginExtInfo);
		bool GetName(CString& pluginName);
		bool GetID(CString& pluginID);
		int GetCaps(int capsIndex);

		int GetNumParams();
		bool GetParamName(int paramIndex, CString& paramName);
		int GetParamType(int paramIndex);
		float GetParamDefault(int paramIndex);

		float GetParamValue(int paramIndex);
		bool SetParamValue(int paramIndex, float value);
		bool ProcessFrame(char* frame);

	protected:

		Free();
		void CopyFFString(CString& dst, BYTE* src, int length);

		FF_Main_FuncPtr mainPtr;	// pointer to plugin's plugMain function
		HINSTANCE hInst;			// instance handle of plugin's dll
		LPVOID instID;				// plugin's instance ID

/*
	// initialize a FreeFrame plugin
	FFPlugin ffPlug;
	ffPlug.Load("resHeat.dll");

	VideoInfoStruct vidInfo;
	vidInfo.BitDepth = FF_CAP_32BITVIDEO;
	vidInfo.FrameHeight = curFrame->height;
	vidInfo.FrameWidth = curFrame->width;
	vidInfo.Orientation = 1;

	FFInstance ffInst;
	ffInst.Create(&ffPlug, vidInfo);

	float tmpVal = ffInst.GetParam(0);
	ffInst.SetParam(1, i);
	ffInst.ProcessFrame(bitIm32->imageData);//curFrame->imageData);
*/
	};

#endif
